<template lang="pug">
div
  q-page(padding)
    .text-h3.text-center.q-mb-xl.q-mt-lg.text-secondary {{ $t('academy_members') }}
    q-infinite-scroll(scroll-target="body", ref="scroller", @load="onLoad")
      template(v-slot:loading)
        .row.justify-center.q-my-md
          q-spinner-dots(color="primary", size="40px")

      .text-center(v-if="!users.length && !loading") {{ $t('no_submissions') }}
      .row.q-col-gutter-md
        .col-12.col-sm-6.col-md-4.col-lg-3(
          v-for="user in users",
          :key="user.id"
        )
          .profileborder.overflow-hidden
            .row
              .col-auto
                q-avatar.bg-grey-5.on-left(circle, size="100px")
                  q-img(:src="user.photo_url", v-if="user.photo_url")
                  q-icon(:name="matPerson", v-if="!user.photo_url")
              .col.self-center
                div
                  strong.text-body-3 {{ user.user_name }}
                q-btn.q-mt-sm(
                  dense,
                  v-if="user.profile_url",
                  type="a",
                  :href="user.profile_url",
                  target="_blank",
                  unelevated,
                  color="blue-9"
                )
                  q-icon.on-left(:name="fabLinkedinIn")
                  span {{ $t('view_profile') }}
              .col-auto.self-center.on-left
                q-chip.q-pl-none.q-pr-none(
                  rounded,
                  v-if="user.submissions",
                  color="transparent",
                  text-color="white"
                )
                  .flag {{ getSubRegion(user).flag }}
                  q-tooltip {{ getSubRegion(user).name }}
</template>

<script>
import { mapState, mapActions } from "vuex";
import Language from "@/mixins/Language";
import find from "lodash/find";
let regions = require("../ifrclist.json");
export default {
  props: ["logo", "filter"],
  mixins: [Language],
  async mounted() {
    this.logo.filter = false;
    await this.initConfig();
  },
  beforeDestroy() {
    this.logo.filter = false;
  },
  data: () => {
    return {
      loading: true,
    };
  },
  watch: {
    filter: {
      immediate: false,
      deep: true,
      handler() {
        this.resetUsers();
        this.$refs.scroller.reset();
        this.$refs.scroller.resume();
        this.$refs.scroller.trigger();
      },
    },
  },
  methods: {
    getSubRegion(user) {
      if (user.submissions.length)
        return this.getRegion(user.submissions[0].region);
      else return "";
    },
    getRegion(region) {
      return find(regions, { code: region });
    },
    async onLoad(index, done) {
      let lastlen = this.users.length;
      this.loading = true;
      await this.getUsers(this.filter);

      let currentlen = this.users.length;
      this.loading = false;

      done(lastlen == currentlen);
    },
    ...mapActions(["getUsers", "initConfig", "resetUsers"]),
  },
  computed: {
    ...mapState(["users", "config"]),
  },
};
</script>

<style>
.profileborder {
  border: 1px solid silver;
  border-radius: 50px;
}

.text-body-3 {
  font-size: 1.3em;
}
</style>
